var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
var path = require('path');
var HtmlWebpackPlugin = require('@builder/pack/deps/html-webpack-plugin');
var _a = require('@builder/app-helpers'), analyzeRuntime = _a.analyzeRuntime, analyzeAuth = _a.analyzeAuth, globSourceFiles = _a.globSourceFiles;
var _b = require('./utils'), getWebOutputPath = _b.getWebOutputPath, logWebpackConfig = _b.logWebpackConfig;
module.exports = function (api) {
    var context = api.context, onHook = api.onHook, onGetWebpackConfig = api.onGetWebpackConfig, applyMethod = api.applyMethod, log = api.log;
    var userConfig = context.userConfig, rootDir = context.rootDir;
    function disableRuntimePlugin(pluginName) {
        applyMethod('addDisableRuntimePlugin', pluginName);
        log.info('[analyze]', "".concat(pluginName, " removed after runtime analyse"));
    }
    if (userConfig.optimizeRuntime && !userConfig.mpa && !userConfig.disableRuntime) {
        // analyze source folder when SPA
        onHook('before.build.load', function () { return __awaiter(_this, void 0, void 0, function () {
            var sourceFiles, runtimeUsedMap, filterRuntime;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, globSourceFiles(path.join(rootDir, 'src'))];
                    case 1:
                        sourceFiles = _b.sent();
                        return [4 /*yield*/, analyzeRuntime(sourceFiles, { rootDir: rootDir })];
                    case 2:
                        runtimeUsedMap = _b.sent();
                        filterRuntime = Array.isArray((_a = userConfig.optimizeRuntime) === null || _a === void 0 ? void 0 : _a.keep) ? userConfig.optimizeRuntime.keep : [];
                        Object.keys(runtimeUsedMap).filter(function (pluginName) { return !filterRuntime.includes(pluginName); }).forEach(function (pluginName) {
                            var isUsed = runtimeUsedMap[pluginName];
                            if (!isUsed) {
                                if (pluginName === 'build-plugin-ice-auth') {
                                    try {
                                        var appEntry = path.join(rootDir, 'src/app');
                                        var hasAuthConfig = analyzeAuth(appEntry);
                                        if (!hasAuthConfig) {
                                            disableRuntimePlugin(pluginName);
                                        }
                                    }
                                    catch (e) {
                                        console.log('[Error] errors occurred with analyze runApp');
                                    }
                                }
                                else {
                                    disableRuntimePlugin(pluginName);
                                }
                            }
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    }
    onHook('before.build.run', function (_a) {
        var config = _a.config;
        logWebpackConfig(config);
    });
    onGetWebpackConfig(function (config) {
        var outputPath = getWebOutputPath(context);
        config.output.path(outputPath);
        // make a copy of html-webpack-plugin to generate 404.html
        if (config.plugins.get('HtmlWebpackPlugin')) {
            config
                .plugin('HtmlWebpackPlugin_404')
                .use(HtmlWebpackPlugin, [__assign(__assign({}, config.plugin('HtmlWebpackPlugin').get('args')[0]), { filename: '404.html' })]);
        }
    });
};
//# sourceMappingURL=setBuild.js.map